1.1 Gutenberg Corpus

import nltk
nltk.download('gutenberg')
nltk.corpus.gutenberg.fileids ()

выберем первый из этих текстов - Эмма Джейн Остин - и дадим ему короткое имя, Эмма , а затем выясним, сколько слов он содержит:
emma = nltk.corpus.gutenberg.words('austen-emma.txt')
len(emma)

emma = nltk.Text(nltk.corpus.gutenberg.words('austen-emma.txt'))
emma.concordance("surprize")

программа отображает три статистических показателя для каждого текста: среднюю длину слова, среднюю длину предложения и количество раз, 
когда каждый элемент словарного запаса встречается в тексте в среднем (наш показатель лексического разнообразия). 
import nltk
nltk.download('gutenberg')
nltk.download('punkt')
from nltk.corpus import gutenberg

for fileid in gutenberg.fileids():
  num_chars = len(gutenberg.raw(fileid))
  num_words = len(gutenberg.words(fileid))
  num_sents = len(gutenberg.sents(fileid))
  num_vocab = len(set(w.lower() for w in gutenberg.words(fileid)))
  print(round(num_chars/num_words), round(num_words/num_sents), round(num_words/num_vocab), fileid)

1.2 Web and Chat Text

 
коллекция веб-текста NLTK включает в себя контент дискуссионного форума 
Firefox, разговоры, подслушанные в Нью-Йорке, сценарий фильма « Пираты Карибского моря» , личную рекламу и обзоры вин:
import nltk
nltk.download('webtext')
from nltk.corpus import webtext
for fileid in webtext.fileids():
    
  print(fileid, webtext.raw(fileid)[:65], '...')

Обращение к отдельным чатам

import nltk
nltk.download('nps_chat')
from nltk.corpus import nps_chat
chatroom = nps_chat.posts('10-19-20s_706posts.xml')
chatroom[123]

1.3. Brown Corpus
можем получить доступ к корпусу как к списку слов или списку предложений (где каждое предложение само 
по себе является просто списком слов). При желании мы можем указать определенные категории или файлы для чтения:

import nltk
nltk.download('brown')
from nltk.corpus import brown
brown.categories()
brown.words(categories='news')
brown.sents(categories=['news', 'editorial', 'reviews'])
news_text = brown.words(categories='news')
fdist = nltk.FreqDist(w.lower() for w in news_text)
modals = ['can', 'could', 'may', 'might', 'must', 'will']
for m in modals:
   print(m + ':', fdist[m], end=' ')

нужно получить количество для каждого интересующего жанра. Мы будем использовать поддержку NLTK для условного частотного распределения. 

cfd = nltk.ConditionalFreqDist(
          (genre, word)
           for genre in brown.categories()
           for word in brown.words(categories=genre))
 genres = ['news', 'religion', 'hobbies', 'science_fiction', 'romance', 'humor']
 modals = ['can', 'could', 'may', 'might', 'must', 'will']
 cfd.tabulate(conditions=genres, samples=modals)

1.4 Reuters Corpus

содержит 10 788 новостных документов общим объемом 1,3 миллиона слов. Документы были разделены на 90 тем и сгруппированы в два набора, 
которые называются «обучающими» и «тестовыми»; таким образом, текст с идентификатором файла 'test / 14826' представляет собой документ, 
взятый из набора тестов. 

import nltk
nltk.download('reuters')
from nltk.corpus import reuters
reuters.fileids()
reuters.categories()

Категории полей можно сортировать.
категории в корпусе Reuters пересекаются друг с другом просто потому, что новость часто охватывает несколько тем. Мы можем запросить темы, 
охватываемые одним или несколькими документами, или документы, включенные в одну или несколько категорий. 

reuters.categories('training/9865')

reuters.categories(['training/9865', 'training/9880'])

reuters.words(categories=['barley', 'corn'])
можем указать слова или предложения, которые нам нужны, в терминах файлов или категорий. Первые несколько слов в каждом из этих текстов - 
это заголовки, которые по соглашению хранятся в верхнем регистре.

>>> reuters.words('training/9865')[:14]
['FRENCH', 'FREE', 'MARKET', 'CEREAL', 'EXPORT', 'BIDS',
'DETAILED', 'French', 'operators', 'have', 'requested', 'licences', 'to', 'export']
>>> reuters.words(['training/9865', 'training/9880'])
['FRENCH', 'FREE', 'MARKET', 'CEREAL', 'EXPORT', ...]
>>> reuters.words(categories='barley')
['FRENCH', 'FREE', 'MARKET', 'CEREAL', 'EXPORT', ...]
>>> reuters.words(categories=['barley', 'corn'])
['THAI', 'TRADE', 'DEFICIT', 'WIDENS', 'IN', 'FIRST', ...]

1.5 Inaugural Address Corpus

 корпус представляет собой сборник из 55 текстов, по одному на каждое президентское послание. 
Интересным свойством этой коллекции является ее временное измерение.
год каждого текста указан в его имени файла. Чтобы получить год из имени файла, мы извлекли первые четыре символа, 
используя fileid [: 4] .
посмотрим, как со временем используются слова Америка и гражданин 

import nltk
nltk.download('inaugural')
from nltk.corpus import inaugural
cfd = nltk.ConditionalFreqDist (
               (target, fileid [: 4])
               for fileid in inaugural.fileids()
               for w in inaugural.words(fileid)
               for target in ['america', 'citizen']
               if w.lower().startswith(target))
cfd.plot()

1.7   Corpora in Other Languages
Последний из этих корпусов содержит Всеобщую Декларацию прав человека на более чем 300 языках. 
Идентификаторы файлов для этого корпуса включают в себя информация о кодировке символов, используемой 
в файле, например, UTF8 или Latin1.

import nltk
nltk.download('cess_esp')
nltk.corpus.cess_esp.words()
nltk.corpus.udhr.words('Javanese-Latin1')[11:]


nltk.download('floresta')
nltk.corpus.floresta.words()

nltk.download('indian')
nltk.corpus.indian.words('hindi.pos')

nltk.download('udhr')
##nltk.corpus.udhr.fileids()
nltk.corpus.udhr.words('Javanese-Latin1')[11:]

Кумулятивные Распределения Длины Слов: Обработано шесть переводов Всеобщей Декларации Прав Человека; этот график показывает, 
что слова, имеющие 5 или менее букв, составляют около 80% текста Ibibio, 60% текста на немецком языке и 25% текста Inuktitut.

import nltk
nltk.download('udhr')
from nltk.corpus import udhr
languages = ['Chickasaw', 'English', 'German_Deutsch',
   'Greenlandic_Inuktikut', 'Hungarian_Magyar', 'Ibibio_Efik']
cfd = nltk.ConditionalFreqDist(
           (lang, len(word))
          for lang in languages
           for word in udhr.words(lang + '-Latin1'))
cfd.plot(cumulative=True)





